/* Copyright (c) 2000-2001 ActiveState SRL. 
   See the file LICENSE.txt for licensing information. */

/* -*- Mode: JavaScript; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * Komodo's Tip of the Day dialog
 *
 */


//---- globals

var _gTip_log = getLoggingMgr().getLogger("tipoftheday");

var _gTip_numTips = 45;
var _gTip_prefSvc = null;

var _gTip_contentWidget = null; // the DOM node for the tip content
var _gTip_prefix = null;        // prefix for tip URLs


//---- interface routines for tipoftheday.xul

function Tip_OnLoad(prefix /*=""*/, contentWidget /*="tip-content" node*/)
{
    try {
        trace_onload();

        if (typeof(contentWidget) == "undefined" || !contentWidget)
            contentWidget = document.getElementById("tip-content");
        if (typeof(prefix) == "undefined" || !prefix) prefix = "";
        _gTip_contentWidget = contentWidget;
        _gTip_prefix = prefix;
        
        _gTip_prefSvc = Components.classes["@activestate.com/koPrefService;1"].
                    getService(Components.interfaces.koIPrefService);
        if (document.getElementById("dialog")) {
            var dialog = document.getElementById("dialog");
            var prevButton = dialog.getButton('extra1');
            prevButton.setAttribute('label', 'Previous Tip');
            prevButton.setAttribute('accesskey', 'P');
            var nextButton = dialog.getButton('extra2');
            nextButton.setAttribute('label', 'Next Tip');
            nextButton.setAttribute('accesskey', 'N');
            var closeButton = dialog.getButton('cancel');
            closeButton.setAttribute('label', 'Close');
            closeButton.setAttribute('accesskey', 'C');
            var showAtStartup = _gTip_prefSvc.prefs.getBooleanPref("tipShowAtStartup");
            document.getElementById("show-tip-checkbox").checked = showAtStartup;
            closeButton.focus();
            //SetWindowLocation();
        }
        Tip_NextTip();
    } catch (e) {
        _gTip_log.exception(e);
    }
}

function Tip_OnUnload()
{
    var showAtStartup = document.getElementById("show-tip-checkbox").checked;
    _gTip_prefSvc.prefs.setBooleanPref("tipShowAtStartup", showAtStartup);
}

function _Tip_Num2Url(tipNumber)
{
    return "chrome://jaguar/content/tipoftheday/"+_gTip_prefix+"tip"+
           tipNumber+".html";
}


function Tip_NextTip()
{
    try {
        // Get the current tip number and increment it.
        var tipNumber = _gTip_prefSvc.prefs.getLongPref("tipNumber");
        tipNumber = (Number(tipNumber) + 1) % _gTip_numTips;

        // Display that tip.
        var tipUrl = _Tip_Num2Url(tipNumber);
        //dump("Tip_NextTip(): setting tip to " + tipUrl + "\n");
        _gTip_contentWidget.setAttribute("src", tipUrl);
        
        // Save the new tip number.
        _gTip_prefSvc.prefs.setLongPref("tipNumber", tipNumber);
    } catch (e) {
        _gTip_log.exception(e);
    }
}


function Tip_PreviousTip()
{
    try {
        // Get the current tip number and decrement it.
        var tipNumber = _gTip_prefSvc.prefs.getLongPref("tipNumber");
        tipNumber = Number(tipNumber) - 1;
        if (tipNumber < 0) tipNumber = _gTip_numTips-1;

        // Display that tip.
        var tipUrl = _Tip_Num2Url(tipNumber);
        //dump("Tip_PreviousTip(): setting tip to " + tipUrl + "\n");
        _gTip_contentWidget.setAttribute("src", tipUrl);
        
        // Save the new tip number.
        _gTip_prefSvc.prefs.setLongPref("tipNumber", tipNumber);
    } catch (e) {
        _gTip_log.exception(e);
    }
}


// Routine for some tip content HTML to call.
function Tip_OpenPrefsPanel(name)
{
    if (document.getElementById("dialog")) {
        opener.prefs_doGlobalPrefs(name);
    } else {
        prefs_doGlobalPrefs(name);
    }
}

function Tip_OpenHelp(page)
{
    if (document.getElementById("dialog")) {
        opener.launch_MainHelp(page);
    } else {
        launch_MainHelp(page);
    }
}

function Tip_OpenHelpTag(tag)
{
    if (document.getElementById("dialog")) {
        opener.launch_MainHelpTag(tag);
    } else {
        launch_MainHelpTag(tag);
    }
}
